package com.zcloud.zcGbsServicer.web;


import com.zcloud.zcGbsServicer.api.ResourcePersonServiceI;
import com.zcloud.zcGbsServicer.dto.ResourcePersonAddCmd;
import com.zcloud.zcGbsServicer.dto.ResourcePersonPageQry;
import com.zcloud.zcGbsServicer.dto.ResourcePersonUpdateCmd;
import com.zcloud.zcGbsServicer.dto.clientobject.ResourcePersonCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
/**
* web-adapter
* @Author makejava
* @Date 2026-01-21 17:23:34
*/
@Api(tags = "资源-人员(通用)")
@RequestMapping("/${application.gateway}/resourcePerson")
@RestController
@AllArgsConstructor
public class ResourcePersonController {
    private final ResourcePersonServiceI resourcePersonService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<ResourcePersonCO> add(@Validated @RequestBody ResourcePersonAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        return resourcePersonService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<ResourcePersonCO> page(@RequestBody ResourcePersonPageQry qry) {
        return resourcePersonService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<ResourcePersonCO> listAll() {
        return MultiResponse.of(new ArrayList<ResourcePersonCO>());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<ResourcePersonCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(new ResourcePersonCO());
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        resourcePersonService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
        public Response removeBatch(@RequestParam Long[] ids) {
        resourcePersonService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody ResourcePersonUpdateCmd resourcePersonUpdateCmd) {
        resourcePersonService.edit(resourcePersonUpdateCmd);
        return SingleResponse.buildSuccess();
    }
}

